# Creatio.Error.Handler
 
Creatio.Error.Handler it is a Node JS package that contains all error handler services. This package can be applied to any web component such as:
- NodeJS Envs
- Cloud Function
- Google App Engine
- Google Cloud Run
- Google Kubernate Engine
- Node Express Server


## Getting Started

1. Install enviroment (NodeJS)
2. Install dependencies: npm install
3. Build: npm run build
4. Publish: npm publish


## Build and Test

* Build: npm run build
* Test: npm run test
* TDD: npm run tdd


## Documentation

### Creatio Packages Dependencies

![Creatio Packages Dependencies](docs/package.png "Creatio Packages Dependencies")

### TypeDocs

[Creatio TypeDocs](docs/typedoc/index.html)

### Table of Contents

-   [Entity][1]
    -   [BaseError][2]
    -   [EntityError][3]
    -   [InternalError][4]
    -   [ValidationError][5]
    -   [UncodedError][6]
    -   [ErrorResponse][7]
-   [Enum][8]
    -   [ErrorStatus][9]
    -   [ErrorCode][10]
-   [Handler][11]
    -   [CustomErrorHandler][12]
-   [Middleware][13]
    -   [ExpressErrorHandlerMiddleware][14]

## Entity

Class set to manage entities

## BaseError

```Base Error class to represent errors```

## EntityError

```Entity Error class to represent entity errors```

## InternalError

```Internal Error class to represent server errors```

## ValidationError

```Validation Error class to represent entity validation errors```

## UncodedError

```Uncoded Error class to represent an errors```

### ErrorResponse

```HttpError type class to represent errors```


### Enum

Emuns set to errors

### ErrorStatus

```Error Status enum to represent  Hypertext Transfer Protocol (HTTP) response status codes.```

### ErrorCode

```Error Code enum to represent  Creatio Code Errors.```


## Handler

Class set to handle errors

### CustomErrorHandler

```Handling application errors```


## Middleware

Class set to handle application errors

### ExpressErrorHandlerMiddleware

```Middleware to handle application errors```


[1]: #entity

[2]: #baseError

[3]: #entityError

[4]: #internalError

[5]: #validationError

[6]: #uncodedError

[7]: #errorResponse

[8]: #enum

[9]: #errorStatus

[10]: #errorCode

[11]: #handler

[12]: #customErrorHandler

[13]: #middleware

[14]: #expressErrorHandlerMiddleware


## Contribute

If you are interested in fixing issues and contributing directly to the code,
please contact to the project manager. Here is how you can contribute to Creatio.Error.Handler:

* Submit bugs and help us verify fixes
* Submit pull requests for bug fixes and features and discuss existing proposals