"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InternalError = void 0;
const core_1 = require("@creatio-tech/core");
const class_validator_1 = require("class-validator");
const error_code_1 = require("../../enum/error.code");
const validation_error_1 = require("./validation.error");
class InternalError extends core_1.BaseError {
    static async validate(instance) {
        const validationError = await (0, class_validator_1.validate)(instance, {
            validationError: { target: false, value: false },
        });
        if (validationError.length > 0) {
            return new validation_error_1.ValidationError(core_1.ErrorStatus.UNPROCESSABLE_ENTITY, 'validation_errors', error_code_1.ErrorCode.UNPROCESSABLE_ENTITY_BASE, InternalError.TypeName, core_1.ValidatorHelper.getValidation(validationError));
        }
        return undefined;
    }
    async validate() {
        return await InternalError.validate(this);
    }
    static plainToClass(source) {
        const instance = new InternalError();
        if (source !== undefined) {
            instance.status = Object.values(core_1.ErrorStatus).includes(source.status) === true
                ? core_1.ErrorStatus[source.status]
                : core_1.ErrorStatus.NONE;
            instance.message = core_1.StringHelper.transformString(source.message);
            instance.code = Object.values(error_code_1.ErrorCode).includes(source.code) === true
                ? error_code_1.ErrorCode[source.code]
                : error_code_1.ErrorCode.NONE;
        }
        return instance;
    }
    static classToClass(source) {
        const instance = new InternalError();
        if (source !== undefined) {
            instance.status = source.status;
            instance.message = core_1.StringHelper.transformString(source.message);
            instance.code = source.code;
        }
        return instance;
    }
    constructor(status, message, code) {
        super();
        this.status = status !== null && status !== void 0 ? status : core_1.ErrorStatus.NONE;
        this.message = message !== null && message !== void 0 ? message : '';
        this.code = code !== null && code !== void 0 ? code : error_code_1.ErrorCode.NONE;
    }
}
exports.InternalError = InternalError;
InternalError.TypeName = 'InternalError';
__decorate([
    (0, class_validator_1.IsEnum)(error_code_1.ErrorCode),
    (0, class_validator_1.IsNotEmpty)(),
    (0, class_validator_1.NotEquals)(core_1.ErrorStatus.NONE),
    __metadata("design:type", Number)
], InternalError.prototype, "code", void 0);
//# sourceMappingURL=internal.error.js.map