"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExpressErrorHandlerMiddleware = void 0;
const routing_controllers_1 = require("routing-controllers");
const logging_1 = require("@creatio-tech/logging");
const custom_error_handler_1 = require("../handler/custom.error.handler");
let ExpressErrorHandlerMiddleware = exports.ExpressErrorHandlerMiddleware = class ExpressErrorHandlerMiddleware {
    constructor(errorHandler) {
        this.errorHandler = errorHandler;
    }
    error(error, request, response, next) {
        (0, logging_1.Logger)().info(`Error Handler on Request: ${request.hostname}${request.originalUrl}`);
        if (this.errorHandler === undefined) {
            this.errorHandler = new custom_error_handler_1.CustomErrorHandler();
        }
        this.errorHandler.handleError(error, request, response, next);
    }
};
exports.ExpressErrorHandlerMiddleware = ExpressErrorHandlerMiddleware = __decorate([
    (0, routing_controllers_1.Middleware)({ type: 'after' }),
    __metadata("design:paramtypes", [custom_error_handler_1.CustomErrorHandler])
], ExpressErrorHandlerMiddleware);
//# sourceMappingURL=express.error.handler.middleware.js.map